import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataCloudinitConfigConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/cloudinit/d/config#base64_encode DataCloudinitConfig#base64_encode}
    */
    readonly base64Encode?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/cloudinit/d/config#boundary DataCloudinitConfig#boundary}
    */
    readonly boundary?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/cloudinit/d/config#gzip DataCloudinitConfig#gzip}
    */
    readonly gzip?: boolean | cdktf.IResolvable;
    /**
    * part block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/cloudinit/d/config#part DataCloudinitConfig#part}
    */
    readonly part: DataCloudinitConfigPart[] | cdktf.IResolvable;
}
export interface DataCloudinitConfigPart {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/cloudinit/d/config#content DataCloudinitConfig#content}
    */
    readonly content: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/cloudinit/d/config#content_type DataCloudinitConfig#content_type}
    */
    readonly contentType?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/cloudinit/d/config#filename DataCloudinitConfig#filename}
    */
    readonly filename?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/cloudinit/d/config#merge_type DataCloudinitConfig#merge_type}
    */
    readonly mergeType?: string;
}
export declare function dataCloudinitConfigPartToTerraform(struct?: DataCloudinitConfigPart | cdktf.IResolvable): any;
/**
* Represents a {@link https://www.terraform.io/docs/providers/cloudinit/d/config cloudinit_config}
*/
export declare class DataCloudinitConfig extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "cloudinit_config";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/cloudinit/d/config cloudinit_config} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataCloudinitConfigConfig
    */
    constructor(scope: Construct, id: string, config: DataCloudinitConfigConfig);
    private _base64Encode?;
    get base64Encode(): boolean | cdktf.IResolvable;
    set base64Encode(value: boolean | cdktf.IResolvable);
    resetBase64Encode(): void;
    get base64EncodeInput(): boolean | cdktf.IResolvable | undefined;
    private _boundary?;
    get boundary(): string;
    set boundary(value: string);
    resetBoundary(): void;
    get boundaryInput(): string | undefined;
    private _gzip?;
    get gzip(): boolean | cdktf.IResolvable;
    set gzip(value: boolean | cdktf.IResolvable);
    resetGzip(): void;
    get gzipInput(): boolean | cdktf.IResolvable | undefined;
    get id(): string;
    get rendered(): string;
    private _part?;
    get part(): DataCloudinitConfigPart[] | cdktf.IResolvable;
    set part(value: DataCloudinitConfigPart[] | cdktf.IResolvable);
    get partInput(): cdktf.IResolvable | DataCloudinitConfigPart[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
